package edu.harvard.mgh.purcell.gplink.mainGUI;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;

import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;

//import ch.ethz.ssh2.SCPClient;
import edu.harvard.mgh.purcell.gplink.base_form.GeneralUtil;
import edu.harvard.mgh.purcell.gplink.data.DownloadFile;

/**
 * Create the general popup menu that appears in both the operations
 * and folder viewers.
 * @author Kathe Todd-Brown
 *
 */
@SuppressWarnings("serial")
public abstract class GplinkPopUpMenu extends JPopupMenu {

	String [] localFilenames;
	String [] remoteFilenames;
	String [] opnames;
	MainFrame frame;
	
	ActionListener download = new ActionListener(){

		public void actionPerformed(ActionEvent e) {
			new DownloadFile(remoteFilenames, 
					frame.data.getRoot().getAbsolutePath(), 
					frame.data.getConn(),
					frame).start();
			/*for(int i = 0; i < remoteFilenames.length; i++){
				SCPClient scopy = new SCPClient(frame.data.getConn());
				try {
					scopy.get(GeneralUtil.makeSpacesHard(remoteFilenames[i]),
							frame.data.getRoot().getAbsolutePath());
				} catch (IOException e1) {
					new ErrorDialog(frame, "Error trying to download\n" +
							"[" + GeneralUtil.makeSpacesHard(remoteFilenames[i]) +"]\n"
							+"download:GplinkPopUpMenu.java");
					return;
				}
				
			}*/
		}
		
	};
	/**
	 * Launch the user specified file viewer.
	 */
	ActionListener openAlt = new ActionListener(){
		@SuppressWarnings("static-access")
		public void actionPerformed(ActionEvent event){
			
			for(int i =0; i <localFilenames.length; i++){
				if(frame.inTransit(localFilenames[i]) == false){
					try{
						//open the file in the editor
						String s = frame.data.getEditor() + " " 
								+ GeneralUtil.quoteFilename(localFilenames[i]);
						@SuppressWarnings("unused") 
						Process plink = Runtime.getRuntime().exec(GeneralUtil.stripAndSplit(s),
								null, frame.data.getRoot());
					}
			        catch (IOException e) {
			        	JOptionPane.showMessageDialog(frame,
			    	        	//new ErrorMessageDialog(frame, 
			        			"Error trying to open selected file [ "
			        			+ localFilenames[i] + " ] in " +
			        			"alternate editor [ " + frame.data.getEditor() + " ].\n",
			        			"gPLINK error",
			        			JOptionPane.ERROR_MESSAGE);
			        }
		        } else {
		        	JOptionPane.showMessageDialog(frame,
		    	        	//new ErrorMessageDialog(frame, 
		        			"File still marked as downloading \n [ "
		        			+ localFilenames[i] + " ] \n"
		        			+ "Can not open.",
		        			"gPLINK error",
		        			JOptionPane.ERROR_MESSAGE);
		        }
			}
		}
	};
	
	/**
	 * Launch the default file viewer
	 */
	ActionListener openDefault = new ActionListener(){
		public void actionPerformed(ActionEvent event){
			for(int i = 0; i < localFilenames.length; i++){
				if(frame.inTransit(localFilenames[i]) == false){
					try{
						//open the file in the user spcifed filename
						String s = frame.data.getDefaultEditor() + " "
							+ GeneralUtil.quoteFilename(localFilenames[i]);
						@SuppressWarnings("unused") 
						Process plink = Runtime.getRuntime().exec(GeneralUtil.stripAndSplit(s),
								null, frame.data.getRoot());
					}
			        catch (IOException e) {
			        	JOptionPane.showMessageDialog(frame,
			    	        	//new ErrorMessageDialog(frame, 
			        			"Error trying to open selected file [ "
			        			+ localFilenames[i] + " ] in " +
			        			"default editor [ " + frame.data.getDefaultEditor() + " ].\n",
			        			"gPLINK error",
			        			JOptionPane.ERROR_MESSAGE);
			        }
		        
				} else {
					JOptionPane.showMessageDialog(frame,
	    	        	//new ErrorMessageDialog(frame, 
	        			"File still marked as downloading \n [ "
	        			+ localFilenames[i] + " ] \n"
	        			+ "Can not open.",
	        			"gPLINK error",
	        			JOptionPane.ERROR_MESSAGE);
					}
				}
		}
	};
	
	ActionListener openHaplo = new ActionListener(){

		public void actionPerformed(ActionEvent arg0) {
			if(opnames == null){
				for(int i = 0; i < localFilenames.length; i++){
					if(frame.inTransit(localFilenames[i]) == false){
						new OpenHapDialog(frame, null, localFilenames[i]);
					} else {
						JOptionPane.showMessageDialog(frame,
		    	        	//new ErrorMessageDialog(frame, 
		        			"File still marked as downloading \n [ "
		        			+ localFilenames[i] + " ] \n"
		        			+ "Can not open.",
		        			"gPLINK error",
		        			JOptionPane.ERROR_MESSAGE);
					}
				}
			}
			else{
				for(int i = 0; i < localFilenames.length; i++){
					if(frame.inTransit(localFilenames[i]) == false){
						new OpenHapDialog(frame, opnames[i], localFilenames[i]);
					} else {
						JOptionPane.showMessageDialog(frame,
		    	        	//new ErrorMessageDialog(frame, 
		        			"File still marked as downloading \n [ "
		        			+ localFilenames[i] + " ] \n"
		        			+ "Can not open.",
		        			"gPLINK error",
		        			JOptionPane.ERROR_MESSAGE);
					}
				}
			}
		}
		
	};
	
	ActionListener showHierachyOp = new ActionListener(){
		public void actionPerformed(ActionEvent arg0){
			new HierarchyDialog(opnames[0],
					frame, opnames[0], null);
		}
	};
	
	ActionListener showHierachyFile = new ActionListener(){
		public void actionPerformed(ActionEvent arg0){
			if(frame.data.isRemote(true))
				new HierarchyDialog(GeneralUtil.fileName(remoteFilenames[0]),
					frame, null, remoteFilenames[0]);
			else
				new HierarchyDialog(GeneralUtil.fileName(localFilenames[0]),
						frame, null, localFilenames[0]);
		
		}
	};
	
	public GplinkPopUpMenu(MainFrame mf, 
			String [] givenFiles, String [] givenOp){
		super();
		opnames = givenOp;		
		frame = mf;
		
		boolean openFile = false;
		
		if(givenFiles != null && givenFiles.length != 0){
			if(frame.data.isRemote(false)){
				remoteFilenames = new String[givenFiles.length];
				for(int i = 0; i < givenFiles.length; i++){
					remoteFilenames[i] = frame.data.getRemoteFile() 
						+"/"+ GeneralUtil.fileName(givenFiles[i]);
				}
			}
			localFilenames = new String[givenFiles.length];
			for(int i = 0; i < givenFiles.length; i++){
				localFilenames[i] = new File(frame.data.getRoot(),
						GeneralUtil.fileName(givenFiles[i])).getAbsolutePath();
			}
			openFile = true;
		
			if(openFile == true){
				JMenuItem getFile = new JMenuItem("Download file");
				getFile.addActionListener(download);
		
				//check that the file isn't already there
				boolean localCopy = true;
				for(int i = 0; i < localFilenames.length; i++){
					if( ! new File(localFilenames[i]).exists())
						localCopy = false;
				}
				
				if(frame.data.isRemote(false) == true
						&& localCopy == false){
					//add download to the menu
					add(getFile);
					add(new JPopupMenu.Separator());
				}
				
				if(localCopy == true){
					JMenuItem open = new JMenuItem("Open in default viewer");
					open.addActionListener(openDefault);
					add(open);
					
					JMenuItem openAlter = new JMenuItem("Open in alternate viewer");
					openAlter.addActionListener(openAlt);
					add(openAlter);
					
					boolean hapOK = true;
					//if not all the files are haploview ok
					for(int i = 0; i < localFilenames.length; i++){
						if( !OpenHapDialog.hapoloviewOK(localFilenames[i]))
							hapOK = false;
					}
					
					if(hapOK == true
							&& new File(frame.data.getHaploviewPath()).exists() ){
						JMenuItem openInHaplo = new JMenuItem("Open in Haploview");
						openInHaplo.addActionListener(openHaplo);
						add(openInHaplo); 
					}
					add(new JPopupMenu.Separator());
				}
				
			}
			
			JMenuItem fileParents;
			if(frame.data.isRemote(false))
				fileParents = new JMenuItem("Show relations of "+GeneralUtil.fileName(remoteFilenames[0]));
			else
				fileParents = new JMenuItem("Show relations of "+GeneralUtil.fileName(localFilenames[0]));
			fileParents.addActionListener(showHierachyFile);
			
			add(fileParents);
				
		}
		
		
		if(opnames != null){
			JMenuItem opParents = new JMenuItem("Show relations of " + opnames[0]);
			opParents.addActionListener(showHierachyOp);
			add(opParents);
		}
		add(new JPopupMenu.Separator());
	}
	
}
